package com.bocloud.gateway.domain;

import com.alibaba.fastjson.JSONArray;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * @author dmw
 */
@Data
public class GatewayRequest {
    private String uri;
    private Integer order;
    private String serviceId;
    private List<FiltersEntity> filters;
    private List<PredicatesEntity> predicates;
    private String metadata;
    private String remarks;

    public GatewayRequest(String service) {
        this.serviceId = service;
        this.order = 0;
        this.uri = service;
        List<FiltersEntity> filters = new ArrayList<>();
        List<PredicatesEntity> predicates = new ArrayList<>();
        filters.add(FiltersEntity.builder().type("StripPrefix").rule("2").build());
        this.filters = filters;
        String pattern = "/api/" + service + "/**";
        predicates.add(PredicatesEntity.builder().type("Path").predicates(pattern).build());
        this.predicates = predicates;
    }

    public GatewayRoute toGatewayRoute() {
        GatewayRoute route = new GatewayRoute();
        route.setServiceName(this.getServiceId());
        route.setServiceId(this.getServiceId());
        route.setUri(this.getUri());
        route.setPredicates(JSONArray.toJSONString(this.getPredicates()));
        route.setFilters(JSONArray.toJSONString(this.getFilters()));
        route.setOrder(this.getOrder());
        route.setRemarks(this.getRemarks());
        route.setMetaData(this.getMetadata());
        return route;
    }
}